; #########################################################################
; File:       Dialog4.asm
; #########################################################################
      .586                   ; minimum processor needed for 32 bit
      .model flat, stdcall   ; FLAT memory model & STDCALL calling
      option casemap :none   ; set code to case sensitive

; #########################################################################
      include \masm32\include\windows.inc
      
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\gdi32.inc
      
      include  \MASM32\include\comctl32.inc         ; Para InitCommonControls
;..............................................      
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\gdi32.lib
      
      includelib  \MASM32\lib\comctl32.lib          ; Para InitCommonControls
; #########################################################################
WinMain     proto :DWORD,:DWORD,:DWORD,:DWORD
WndProc     proto :DWORD,:DWORD,:DWORD,:DWORD
DlgProc1    proto :DWORD,:DWORD,:DWORD,:DWORD        
; #########################################################################
; defined in resource file
;
IDM_Dlg1       equ 1000
IDM_Close      equ 2000

IDC_Nome       equ 12000
IDC_Morada     equ 12001

IDC_TxtNome    equ 11000
IDC_TxtMorada  equ 11001

IDC_Exit       equ 13000
IDC_Cancela    equ 13001
; ##############################################################################################
.data
align 4
_MenuName       db "DIALOG1", 0                 ; definido em rsrc.rc
align 4
_DefDialog1     db "DefDialog1",0               ; definido em rsrc.r
;...............................................
align 4
_ClassName      db "Class_1", 0
align 4
_DisplayName    db "Dialog 4", 0
align 4
_CommandLine    dd 0
_hWnd           dd 0
_hInstance      dd 0
;....................................................
align 4
_Name           db 28 dup (?)
                db 0
align 4
_Address        db 28 dup (?)
                db 0
; ##############################################################################################
.code
; -----------------------------------------------------------------------
start:          invoke GetModuleHandle, NULL 
                mov    _hInstance, eax

                invoke GetCommandLine        
                mov    _CommandLine, eax

                call     InitCommonControls

                invoke   WinMain, _hInstance, NULL, _CommandLine, SW_SHOWDEFAULT    
                invoke   ExitProcess, eax       
; #########################################################################
WinMain proc hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD
        LOCAL   wc :WNDCLASSEX
        LOCAL   msg:MSG

        mov wc.cbSize,         sizeof WNDCLASSEX
        mov wc.style,          CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
        mov wc.lpfnWndProc,    offset WndProc      
        mov wc.cbClsExtra,     NULL
        mov wc.cbWndExtra,     NULL
        push  hInst
;        push    _hInstance
	  pop   wc.hInstance
        
        mov wc.hbrBackground,  COLOR_BTNFACE+1     ; system color
        mov wc.lpszClassName,  offset _ClassName   ; window class name
        mov wc.lpszMenuName, offset _MenuName      ; menu name in resource file
        
        invoke LoadCursor, NULL, IDC_ARROW         ; system cursor
        mov wc.hCursor,        eax
        mov wc.hIconSm,        0

        invoke RegisterClassEx, ADDR wc            ; register the window class

        ; ==================================
        ; Create the main application window
        ; ==================================
        invoke CreateWindowEx,WS_EX_OVERLAPPEDWINDOW,
                              ADDR _ClassName,
                              ADDR _DisplayName,
                              WS_OVERLAPPEDWINDOW,
                              140, 100, 500, 350,
                              NULL,NULL,
                              hInst,NULL
        mov     _hWnd, eax  

        invoke ShowWindow, _hWnd, SW_SHOWNORMAL      ; display the window
        invoke UpdateWindow, _hWnd                   ; update the display

          ; ************
          ; Message Loop
          ; ************
@@:       invoke GetMessage, ADDR msg, NULL, 0, 0         ; get each message
          cmp    eax, 0                                   ; exit if GetMessage()
          je     @F                                       
          ;
          invoke TranslateMessage, ADDR msg               ; translate it
          invoke DispatchMessage,  ADDR msg               ; send it to message proc
          jmp    @B
          ;
@@:       mov    eax, 0         
          ret
WinMain   endp
; ##############################################################################################
WndProc         proc    hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
                mov     eax, uMsg
                mov     edx, wParam
                mov     ebx, hWin
                ;
                cmp     eax, WM_COMMAND
                jne     _WM_CREATE
                ;
                ;================== menu commands ===========================
                cmp     edx, IDM_Dlg1
                jne     _IDM_Close
                
		    invoke DialogBoxParam, _hInstance, addr _DefDialog1, ebx, 
                                       offset DlgProc1, NULL
                jmp     _eWndProc
                        
_IDM_Close:     cmp     edx, IDM_Close
                jne     _eWndProc
                ;
                invoke   SendMessage, hWin, WM_SYSCOMMAND, SC_CLOSE, NULL
                jmp     _eWndProc
                ;
                ;================= end menu commands ==========================
; 
_WM_CREATE:     cmp     eax, WM_CREATE
                jne     _WM_SIZE

                jmp     _eWndProc               ; doesnt process
; ----------------------------------------------------------------------------------------------
_WM_SIZE:       cmp     eax, WM_SIZE
                jne     _WM_CLOSE

                jmp     _eWndProc          
; 
_WM_CLOSE:      cmp     eax, WM_CLOSE
                ;jne     _WM_DESTROY
                je      @F
; 
_WM_DESTROY:    cmp     eax, WM_DESTROY
                jne     _eWndProc
                ;
@@:             invoke  PostQuitMessage, NULL
                mov     eax, 0 
                ret
; 
_eWndProc::     invoke  DefWindowProc, hWin, uMsg, wParam, lParam
                ret
WndProc         endp
; ##############################################################################################
DlgProc1    proc     hWnd:DWORD, iMsg:DWORD, wParam:DWORD, lParam:DWORD
            
	     .if iMsg==WM_INITDIALOG

		invoke SetDlgItemText, hWnd, IDC_Nome, offset _Name
		invoke SetDlgItemText, hWnd, IDC_Morada, offset _Address

		invoke GetDlgItem, hWnd, IDC_Nome
		invoke SetFocus, eax

	     .elseif iMsg==WM_CLOSE
		invoke EndDialog, hWnd, NULL

;###################################################3
            .elseif iMsg==WM_CTLCOLORDLG

                    invoke GetStockObject, WHITE_BRUSH

            ret     ; return the brush
;###################################################3
            .elseif iMsg== WM_CTLCOLORSTATIC
            
            ; ************************
            ; Altera a cor -> funciona mas background BRANCO
            ; ************************
            invoke    GetSysColor, COLOR_BACKGROUND
            invoke    SetTextColor, wParam, eax     

            ;invoke    SetTextColor, wParam, 0ff0000h
            invoke    GetStockObject, NULL_BRUSH

            ret     ; return the brush
;####################################################
	     .elseif  iMsg==WM_COMMAND
            mov     eax, wParam
            mov     edx,eax
		shr     edx,16
        		.if dx==BN_CLICKED
	       		.if eax==IDC_Exit

				      invoke GetDlgItemText, hWnd, IDC_Nome, addr _Name, 28+1
				      invoke GetDlgItemText, hWnd, IDC_Morada, addr _Address, 28+1
                              ;
                              invoke    SendMessage, hWnd, WM_CLOSE, NULL, NULL                              
                              ;                              
        			.elseif eax==IDC_Cancela        
                              ;
                              invoke SendMessage, hWnd, WM_CLOSE, NULL, NULL
                              
			     .endif
		      .endif
	      .else
		mov eax,FALSE
		ret
        	.endif
            ;
	      mov  eax,TRUE
	      ret
DlgProc1    endp
; #########################################
end start
